(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2013-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: scalar_spec.mli,v 1.15 2014-01-24 16:33:27 fclement Exp $ *)

(** {3 Scalar specification} *)

open Uordered_field_spec;;

open Refinement_types;;

module type SCALAR =
sig
  include ORDERED_FIELD;;
  
  val sum : t sub_parameter -> t;;
  val first_order_indicator :
    t sub_parameter ->
    Umatrix_nonempty_set.dichotomy -> t first_order_indicator
  ;;
  val initial_zonation : t partition -> t zonation;;
end
;;

module type MAKER = functor (Of : ORDERED_FIELD) -> SCALAR;;
